@ECHO OFF
SETLOCAL EnableDelayedExpansion
REM Compiles every scene to an individual file, and then again to a single big file.

IF EXIST "compile.allow" (
    GOTO COMPILE
) ELSE (
    ECHO You should really not touch these scripts unless you know what you're doing.
    SET /P c="Are you sure you want to do this? I'm only going to ask you once if you say yes. Y/[N] "
    ECHO You have entered: !c!
    IF /I "!c!" EQU "Y" GOTO UNWISE
    IF /I "!c!" EQU "y" GOTO UNWISE
)

:WISE
ECHO Wise choice.
PAUSE
GOTO END

:UNWISE
ECHO Very well. Let us begin.
ECHO.>compile.allow
PAUSE

:COMPILE
node .\compile\aSceneCompiler.js --all --out "scenes\compiled\AllScenes_compiled.js" -q
node .\compile\aSceneCompiler.js --all --ind --indout "scenes\compiled" -q

:END
ENDLOCAL
