/**
 * The kobold's relation with the bandits guarding the money transport, 
 * the first encounter in the forest.
 */
function CaravanBandits() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.knowledge = CaravanBanditsKnowledgeEnum.GUARDS;
    
    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};
    
    /**
     * Loads this object from a type-stripped version thereof.
     * @param {CaravanBandits-stripped} caravanBandits A CaravanBandits object, stripped of private members and all functions.
     */
    this.load = function (caravanBandits) {
        if(!caravanBandits) {
            that.load(new CaravanBandits());
            return;
        } 
        that.knowledge = caravanBandits.knowledge;
    };
}
