/**
 * Replace part of the forest bandit encounter.
 * @param {ForestController} controller The forest controller.
 */
function ForestBanditReplace(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var acceptId = "banditReplaceAcceptButton";
    var protestId = "banditReplaceProtestButton";

    var toAccept = new ForestBanditAccept(ctrl);
    var toProtest = new ForestBanditProtest(ctrl);

    var didRock;
    var gender;
    var dick;
    var pants;
    var underwear;
    var bra;


    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            You compliment the leader of the gang for his fine catch.
                            You imagine it's not [i]every[/i] day they manage to [i]capture[/i] one of the most regal creatures around.
                            You remark that you can't help but notice their group's intentions go beyond just robbing the poor lady.
                        [/p]
                        [p]
                            "<span class="bold brightred">We're not sharing! Leave!</span>" comes the reply.
                            You quickly assure him that you aren't looking for a handout of dragoness sex.
                            Instead, you say that you've come here to offer him something [b]even better[/b].
                            Seemingly having piqued his curiosity, you immediately play your hand, and say that instead of the woman,
                            him and his gang could instead feast themselves on [b]your[/b] body, which is far more height-appropriate than a dragoness twice their size.
                        [/p]`;
        if (didRock) {
            toReturn += `[p]
                            You immediately get the feeling your idea wasn't all that well accepted by the group.
                            Just as their leader was about to scold you, the dragoness suddenly makes a move.
                            She swings her free arm at the bandit leader, punching him off of her.
                            With his knife no longer on her neck, the feisty lady kicks off the remaining distracted and surprised gangmembers.
                        [/p]
                        [p]
                            She hops to her feet and bolts into the forest, one of the bandits giving chase before the leader has recovered enough to tell him not to.
                            Once recovered from their light injuries, the three remaining bandits focus their attention on [b]you[/b].
                            They swiftly advance upon you, and before you even properly realize what's going on, they have you surrounded.
                        [/p]`;
        } else {
            toReturn += `[p]
                            You immediately get the feeling your idea wasn't all that well accepted by the group.
                            Just as their leader was about to scold you, the dragoness suddenly makes a move.
                            She wildly flails her right arm about, knocking off the kobold pinning her down.
                            She then swings her freed arm at the bandit leader, punching him off of her.
                            With his knife no longer on her neck, the feisty lady kicks off the remaining distracted and surprised gangmembers.
                        [/p]
                        [p]
                            She hops to her feet and bolts into the forest, two of the bandits giving chase before the leader has recovered enough to tell them not to.
                            Once recovered from their light injuries, the three remaining bandits focus their attention on [b]you[/b].
                            They swiftly advance upon you, and before you even properly realize what's going on, they have you surrounded.
                        [/p]`;
        }
        toReturn += `   [p]
                            "<span class="bold brightred">Offer accepted.</span>" the leader, right in front of you, speaks.
                            You let out a nervous giggle and say you were [i]just kidding[/i].
                            They didn't actually believe that someone would stumble across a bunch of rowdy bandits like themselves and simply offer to have sex with them, right?
                        [/p]
                        [p]
                            Disregarding your excuses, the boss promptly unties his belt, his pants sliding smoothly over his scaled legs down to the leafy forest floor, 
                            leaving him naked from the waist-down, his semi-hard, human-sized member on full display.
                            You struggle to come up with a way out of this.
                            Looking around, you notice the other two kobolds have stripped as well.
                            A mixture of fear and regret begins to spread through your mind.
                        [/p]
                        [p]
                            As you begin to stammer out another witty excuse, the leader of the gang takes a step towards you, 
                            threateningly cupping your jaw and squeezing your cheeks to silence you halfway through your first word.
                            He speaks, in a dead-serious tone, which hugely contrasts with his earlier near-incoherent shouting:
                            "<span class="bold brightred">You cost us a dragoness.
                            You offered us your body.
                            Pray that we don't take your life as well.</span>"
                        [/p]
                        [p]`;

        if (bra && pants) {
            toReturn += `   With his free hand, the kobold reaches for your ${global.kobold.inventory.createItemWithTooltip(bra)},
                            ripping the fabric from your body and tossing it to the side, your meagre chest exposed to the group.
                            From behind, one of the other two kobolds grips your ${global.kobold.inventory.createItemWithTooltip(pants)} by the waistband.
                            Attempting to pull them down, the ruffian tugs on the garment just a little too roughly.
                            A loud ripping noise echoes throughout the forest clearing, and within moments the torn, 
                            shredded remains of your pants join whatever is left of your bra on the leafy forest floor.`;
        } else if (underwear) {
            toReturn += `   With his free hand, the kobold reaches for your ${global.kobold.inventory.createItemWithTooltip(underwear)},
                            ripping the fabric from your body and tossing it to the side, your groin exposed to the group.
                            Your nakedness only adds to your building fear.`;
        }

        toReturn += `   [/p]
                        [p]
                            You move your hands to cover your nudity,
                            but your arms are grabbed and held in place before you even manage to reach your private parts.
                            Your tail, your last bastion of modesty, crudely gets yanked upwards by one of the bandits behind you.
                            The other swats your taut rear with the flat of his hand, letting his palm linger to squeeze the lower end of one of your buttcheeks, 
                            his fingers slipping in between your thighs.
                        [/p]`;
        return  global.parser.parse(toReturn);
    }

    /**
     * Initializes all private variables.
     */
    function initVars() {
        didRock = (ctrl.bandit.getArrivalChoice() === ForestBanditArrivalChoiceEnum.ROCK);
        gender = ctrl.bandit.intervene.replaceGender();
        dick = ctrl.bandit.intervene.replaceDick();
        pants = ctrl.bandit.intervene.replacePants();
        underwear = ctrl.bandit.intervene.replaceUnderwear();
        bra = ctrl.bandit.intervene.replaceBra();
        ctrl.bandit.intervene.replaceRemoveClothing();
    }

    /**
     * Builds and returns the accept choice button.
     */
    function buildAcceptChoice() {
        var disabled = ctrl.bandit.intervene.hasMadeReplaceChoice() ? "disabled" : "";
        var isSelected = ctrl.bandit.intervene.getReplaceChoice() == ForestBanditReplaceChoice.ACCEPT;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${acceptId}" ${disabled} style="font-size: 17px;">Accept your fate</button>`;

        var tooltip = `You can't stop them. Surrender your body to the kobolds.`;
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the protest choice button.
     */
    function buildProtestChoice() {
        var disabled = ctrl.bandit.intervene.hasMadeReplaceChoice() ? "disabled" : "";
        var isSelected = ctrl.bandit.intervene.getReplaceChoice() == ForestBanditReplaceChoice.PROTEST;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${protestId}" ${disabled}>Protest</button>`;

        var tooltip = `You can't let them do this to you. You don't want to lose your virginity to some gang in the middle of nowhere!`;
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 200px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You: </div>`;
        choice += buildAcceptChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildProtestChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables both buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + acceptId), $("#" + protestId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the bargain button.
     */
    function registerAcceptListener() {
        $("#" + acceptId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.bandit.intervene.makeReplaceChoice(ForestBanditReplaceChoice.ACCEPT);
            loadNextPart(toAccept);
        });
    }

    /**
     * Adds a listener to the relieve button.
     */
    function registerProtestListener() {
        $("#" + protestId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.bandit.intervene.makeReplaceChoice(ForestBanditReplaceChoice.PROTEST);
            loadNextPart(toProtest);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = "banditReplace";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (ctrl.bandit.intervene.getBargainChoice() !== ForestBanditBargainChoice.REPLACE) {
            return "";
        }
        initVars();
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += buildChoice();
        part += `</div>`;
        // Build children here.
        part += toAccept.build();
        part += toProtest.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (ctrl.bandit.intervene.getBargainChoice() !== ForestBanditBargainChoice.REPLACE) {
            return;
        }

        toAccept.registerListeners();
        toProtest.registerListeners();

        if (ctrl.bandit.intervene.hasMadeReplaceChoice()) {
            return;
        }

        registerAcceptListener();
        registerProtestListener();
    };
}

var ForestBanditReplaceChoice = {
    ACCEPT: 1,
    PROTEST: 2
};
