#!/bin/sh -e

if ! [ -x "$(command -v node)"]
then
    node server.js
elif ! [ -x "$(command -v nodejs)"]
then
    nodejs server.js
else
    echo "Package nodejs is not installed. Node.js is required for Kobold Adventure's internal webserver to run. Please see https://nodejs.org/en/ for more details."
fi

