/**
 * What the kobold did during the third noon of Varanar.
 */
function NoonThreeShared() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.ate = false; // Ate at the soup kitchen.
    this.stole = false; // Stole the sheep's ring.
    this.gaveHouse = false; // Gave the sheep Cassidy's house.
    this.gaveHouseMentioned = false; // Told the sheep about Cassidy's corpse

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Loads this object from a type-stripped version thereof.
     * @param {Shared-stripped} shared A Shared object, stripped of private members and all functions.
     */
    this.load = function (shared) {
        if (!shared) {
            that.load(new NoonThreeShared());
            return;
        }
        that.ate = shared.ate || false;
        that.stole = shared.stole || false;
        that.gaveHouse = shared.gaveHouse || false;
        that.gaveHouseMentioned = shared.gaveHouseMentioned || false;
    };
}

