/**
 * Hide section of the woods.
 * @param {ForestController} controller The Forest controller.
 */
function ForestWoodsHideSurrenderRock(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new ForestWoodsHideSurrenderRockContinue(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var treeFail = ctrl.treeFail.has();
        var rock = ctrl.intro.getItemChoice() === ItemEnum.ROCK;
        var weapon = ctrl.misc.weapon();
        var pants = ctrl.misc.pants();
        var underwear = ctrl.misc.underwear();
        var dick = ctrl.misc.dick();
        var toReturn = `[p]
                            Game over.
                            They've got you trapped.
                            You [i]could[/i] run, but you doubt you'd be able to get away.
                            If you hadn't squandered away your time by trying to hide, perhaps you'd have stood a chance. 
                            As things are now, your best bet would be to [i]surrender[/i] yourself to them, and [b]hope[/b] they go easy on you.
                        [/p]
                        [p]
                            ${treeFail ? `You` : `You step out of the bush, and`} pre-emptively remove the bag of gold from around your neck.
                            Staring at it longingly, you let out a loud sigh.
                            If only you'd been ${treeFail ? `able to jump a little higher` : `a little [i]smarter[/i]`},
                            you wouldn't have had to part with your one chance at paying your debts.
                            But alas, what's done is done.
                            In some weird way, this is the [b]right[/b] thing to do.
                            You swallow deeply, and mentally prepare yourself for whatever judgement your pursuers may render unto you.
                        [/p]
                        [p]
                            The party comes into view.
                            A big, buff anthromorphic wolf and a human, with a leashed feral dog that barks its lungs out at you.
                            They seem surprised to see you standing here, coinpouch in hand.
                            The human calms his loud pet, threatening to [b]hit it[/b] to make it [b]shut up[/b].
                            Then, the wolf steps towards you.
                        [/p]
                        [p]
                            The broad lupine leans down to bring his head to your level, glaring at you with hate-filled eyes, his large fangs bared.
                            You shiver in fear, frozen in place.
                            Without a word, the man takes the pouch from your hand, bouncing it up and down, as if [i]checking[/i] the weight.
                            Then, finally, he breaks the tense silence.
                            "[color=gblue]So you're our [i]little[/i] [b]thief[/b], huh?[/color]"
                            You barely manage to [b]nod[/b] in response, too scared to speak.
                            "[color=gblue]Did you really think you could [b]steal[/b] from the [b]baron[/b] and get away with it?[/color]"
                            You shake your head no, and stammer out a meek apology.
                        [/p]
                        [p]
                            "[color=gblue]I've [b]eaten[/b] lizards bigger than you.[/color]"
                            The wolf licks his lips, as though salivating at the thought.
                            "[color=gblue]But then again, I've also raised four pups of my own,
                            and one of them is a [b]thieving little shit[/b] just like you.[/color]"
                            The canine tosses the gold pouch to his human accomplice, hitting his mark without even needing to look back.
                        [/p]
                        [p]
                            "[color=gblue]Normally, me and Kajar would cut you up into [b]minced meat[/b] and feed you to Rex for what you did.
                            Rex is the dog, mind you.[/color]"
                            The pooch barks upon hearing its name.
                            "[color=gblue]But since you [b]presented[/b] yourself to us on a [b]silver platter[/b],
                            like a little [b]cub[/b] that [b]knows[/b] it [b]fucked up bigtime[/b], I'll go easy on you.[/color]"
                            A broad grin forms on the wolf's face.
                            "[color=gblue]After all, I know how to handle [b]brats[/b] like none other.[/color]"
                        [/p]
                        [p]
                            "[color=gblue]What do we have here?[/color]" the lupine continues,
                            snatching your ${global.kobold.inventory.createItemWithTooltip(weapon)} from your hand.
                            "[color=gblue]Planning to [b]hurt[/b] someone with this, now were you?[/color]"
                            The wolf grabs your throat, not quite [b]squeezing[/b] it shut, but still making sure you aren't going anywhere.
                            "[color=gblue]I know exactly what to do with you now, you [b]failure[/b] of a [b]bandit[/b].[/color]"
                        [/p]
                        [p]
                            The wolf straightens his back once more, towering over you like a mountain over a valley.
                            Dragging you along by your neck, he brings you to the very same tree you considered climbing earlier.
                            The canine roughly slams your back against the wooden behemoth.
                            With his free hand, he crudely tugs down your
                            ${pants ? `${global.kobold.inventory.createItemWithTooltip(pants)}` : `${global.kobold.inventory.createItemWithTooltip(underwear)}`},
                            your smooth groin on full display.
                        [/p]
                        [p]
                            You try to cover yourself using your tail, but a stern, disapproving, almost [i]fatherly[/i] finger dissuades you.
                            Using his feet, he kicks apart your legs, spreading your thighs and exposing your loins further.
                            While embarrassed, you don't fight the lupine.
                            He could snap you in half without even trying.
                            Then, the wolf presses your very own ${global.kobold.inventory.createItemWithTooltip(weapon)} against your
                            ${dick ? `cock` : `virginal `}slit, and before you even know what's going on,
                            the ${rock ? `blunt object` : `pointy end`} is [b]rammed[/b] inside of you,
                            your velvety insides parting to make room for the unnaturally-shaped intruder.
                        [/p]
                        [p]
                            Your eyes go wide.
                            You [b]scream[/b] in pain, the coarse surface of the ${rock ? `rock` : `stick`} [b]scraping[/b] against your sensitive interior.
                            The canine lets go of your throat.
                            You instantly fall to the ground, clutching your abused groin,
                            your former weapon sticking out of your stretched hole.
                            The human bursts out into laughter.
                            The wolf walks back over to him.
                            They toss the coinpouch, emptied of course, onto your curled up frame.
                            With their gold reclaimed, and punishment dealt out, they start heading back towards the caravan, their feral pet in tow.
                        [/p]
                        [p]
                            You loudly groan in agony, a small amount of blood trickling from your crotch, running over your inner thigh before dripping to the ground.
                            Despite your weapon not being inserted [b]fully[/b], you're still pretty certain
                            ${rock ? `it stretched you to well beyond what you were built to take` : `a few woodchips splintered off and got lodged in your flesh`}.
                            Even worse: this ordeal isn't over yet.
                            You still need to [b]get it out[/b].
                        [/p]
                        [p]
                            Breathing shakily, you reach in between your legs and tentatively tug on the foreign object embedded in your body.
                            It painfully shifts around a bit, sending fresh spikes of torment down your spine.
                            Gritting your teeth, you get a better grip on the ${rock ? `stone` : `branch`}.
                            There's no easy way to do this, so you might as well [b]get it over with[/b] all in one go.
                            With a single, firm [b]tug[/b], you [b]yank[/b] your former weapon from your ${dick ? `cockslit` : `cunt`},
                            letting out a defeated, anguished cry as it chafingly slides from your groin.
                        [/p]
                        [p]
                            The considerable pain is [b]nothing[/b] compared to the [b]shame[/b] and the [b]defilement[/b].
                            You spend several minutes crying on the ground,
                            your most [b]sensitive[/b] spot reduced to a [b]sheath[/b] for  ${rock ? `dirty rocks` : `splintery sticks`}.
                        [/p]
                        [p]
                            You can't believe that cruel wolf actually [b]did[/b] something like that.
                            Even worse: part of your mind believes you [b]deserved[/b] that punishment.
                            All you wanted to do was repay your debt.
                            Instead, you are left broken, bleeding and crying on the soft forest floor, with not a coin to your name.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    You are no longer a ${dick ? `cockslit` : ``} virgin.
                                [/b]
                            [/c]
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = ctrl.preContinue.continued() ? "disabled" : "";
        var isSelected = ctrl.preContinue.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.preContinue.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.surrenderRock.change();
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        next.registerListeners();

        if (ctrl.preContinue.continued()) {
            return;
        }

        registerNextListener();
    };
}
