/**
 * Robbed section of Varanar, Morning Three.
 * @param {MorningThreeController} controller The Morning Three controller.
 */
function MorningThreeRobbed(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = false;
    var subController = ctrl.preContinue;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new MorningThreeRobbedContinue(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.varanar.dayThree.morning.stolenFrom = true;
        var dick = ctrl.misc.dick();
        var She = dick ? `She` : `He`;
        var he = She.toLowerCase();
        var Her = dick ? `Her` : `His`;
        var his = Her.toLowerCase();
        var Him = dick ? `Her` : `Him`;
        var her = Him.toLowerCase();
        var toReturn = `[p]
                            You [i]could[/i] use some cheering up after such a hellish night,
                            and you don't want to look [i]weird[/i] in front of your new friend.
                            Plus it'll be nice to get some [i]retribution[/i] on a non-kobold.
                            After all, knights are supposed to [b]punish[/b] evildoers,
                            and the bird on stage must have done [i]something[/i] to earn his place in the spotlight.
                            With an abundance of reasons to throw, and none to hold back, you decide to let loose and pelt away.
                        [/p]
                        [p]
                            With a small grunt, you chuck your first egg at the trapped avian.
                            The rotten would-be-breakfast soars through the air with a slight curve, before hitting the bird squarely in the face!
                            It cracks open, the disgusting goop contained within splattering all over the man's feathery face, most of the stuff flowing down along his beak.
                            Some of it manages to make its way into his mouth.
                            He gags, sputters and spits.
                            The cyan kobold burst out into laughter, and you join in.
                            "[color=cyan]Rotten like your wife's clutches![/color]"
                            ${She} turns to you.
                            "[color=cyan]Hit'em with the other one![/color]"
                        [/p]
                        [p]
                            You don't comply right away.
                            Instead, you hold on to the second egg for a few moments,
                            putting all your [b]fear[/b] and [b]anger[/b] and [b]frustration[/b] into it,
                            as if enchanting it with every [b]semblance[/b] of your misfortune you've [b]ever[/b] had to deal with,
                            all the while [i]aiming[/i] your shot to make sure it'll hit its mark.
                            Only after pouring your very heart and soul into the impending throw, with a surge of great fury and determination, do you let loose.
                        [/p]
                        [p]
                            Like the last, the rotten egg flies gracefully through the air towards its avian target.
                            It seems you may have spent just a little bit [i]too[/i] long aiming, however.
                            Unlike your nigh-perfect first pitch, the second projectile misses the bird's face completely,
                            instead hitting the pillory's confining wood.
                            Oh well, at least some of the rancid splatter still made it to the side of his face.
                        [/p]
                        [p]
                            That second throw made you feel a [b]lot[/b] better.
                            It's as though a weight has been lifted off of your shoulders.
                            You turn to face your new friend once more, only to find out ${he}'s nowhere to be found.
                            ${She} must have disappeared into the crowd.
                            Odd.
                        [/p]
                        ${global.ui.condFail(`Charisma below 6`)}`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.robbed.change();
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
