/**
 * Thievery section of Varanar, Morning Three.
 * @param {MorningThreeController} controller The Morning Three controller.
 */
function MorningThreeThrowEgg(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = MorningThreeThieveryChoice.THROW;
    var reqController = ctrl.thievery;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.varanar.dayThree.morning.eggedKobold = true;
        var dick = ctrl.misc.dick();
        var She = dick ? `She` : `He`;
        var he = She.toLowerCase();
        var Her = dick ? `Her` : `His`;
        var his = Her.toLowerCase();
        var Him = dick ? `Her` : `Him`;
        var her = Him.toLowerCase();
        var toReturn = `[p]
                            Having caught ${her} red-handed, you suddenly feel [i]mischievous[/i].
                            The cyan kobold wanted you to throw this second egg, and throw it you will.
                            With a lightning fast motion of your arm, and just a small flick of your wrist, your hurl the rancid projectile ${his} way.
                            It impacts against ${his} face, shattering into a million little pieces,
                            its absolutely [b]rancid[/b] contents splattering all over the kobold's scales. 
                        [/p]
                        [p]
                            As soon as ${he} realizes what just happened, the kobold bursts into tears.
                            ${She} turns tail, and runs away, disappearing into the crowd,
                            probably towards the nearest public bath to wipe the disgusting muck off ${his} face.
                            ${She} got what ${he} deserved, trying to steal from you after [b]pretending[/b] to be your [b]friend[/b].
                        [/p]
                        [p]
                            With the thief having vanished, you decide to stick around and see what happens to the bird on stage.
                            The crowd's relentless hurling of spoilt food continues for the better half of an hour.
                            Then, with the mob running out of things to throw at him, one of the guardsmen, a heavily battle-scarred feline,
                            approaches the avian from behind.
                        [/p]
                        [p]
                            With a single [b]swipe[/b] of the cat's clawed hand, the falcon's pants are ripped to shreds.
                            Kicking apart the bird's legs, the guardsman lowers his own trousers.
                            You watch on in horror, out of sheer morbid curiosity, as the bird begins to [b]beg[/b] for mercy,
                            while the feline lines up his barbed member with the criminal's unlubed feathery butthole.
                            Then, under the exuberant cheers of the crowd, he thrusts forward,
                            the avian squawking in pain and dishonor as his last bit of diginity is publically torn away from him.
                        [/p]
                        [p]
                            While the cat begins to violently hump away at the prisoner's rear, the very pillory itself rocking back and forth with every thrust,
                            you notice a small line starting to form near the steps leading up to the stage.
                            People are paying the guards, for what you can only assume to be their own turn with the bound falcon's ass.
                        [/p]
                        [p]
                            You aren't sure how to feel about this.
                            Turning prisoners into unwilling prostitutes seems morally [b]wrong[/b].
                            But then again, perhaps the bird is a rapist himself.
                            Maybe they're just doing to him what he did to someone else.
                            Either way, you now begin to realize why the guards of Varanar are widely praised as being highly effective at what they do.
                            You wouldn't want to get caught stealing, knowing something like [b]this[/b] might happen to you.
                        [/p]
                        [p]
                            You stick around for a little bit longer, to confirm your suspicions.
                            Indeed, as the feline finishes up and steps aside, the next person in line gets up on stage.
                            A big, burly horse.
                            There won't be much of the falcon left for the rest to enjoy after [i]that guy[/i] is done with him.
                            You turn around and walk away as the equine lowers his pants,
                            not interested in watching half the town have their way with the poor guy who got caught.
                            After all, there [i]are[/i] other things to do on the market square, apart from fucking captive birds.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.continue();
            loadNextPart(ctrl.nextSceneName, ctrl.nextFolderName);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.throwEgg.change();
        part += buildChoice();
        if (!ctrl.nextSceneReady) {
            part += `<span class="todo">There is no content beyond this point.</span>`;
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (ctrl.continued()) {
            return;
        }

        if (ctrl.nextSceneReady) {
            registerContinueListener();
        }
    };
}
